#! /usr/bin/env python

import sys, string
from util import *

usage("""filename""")

optlist, args = parseargs("")

for opt, arg in optlist:
	pass

if len(args) != 1:
	printusage()
	sys.exit(1)

filename = args[0]

c = open('param.c', 'w')
h = open('param.h', 'w')

NXPARAM = 11
NYPARAM = 3

h.write("""/* This file was generated by param.py.  Do not edit. */

#define NXPARAM %d
#define NYPARAM %d

typedef struct {
	int x[NXPARAM];
	double y[NYPARAM];
} XYparam_t;

extern XYparam_t XYparam[];

""" % (NXPARAM, NYPARAM))

c.write("""/* This file was generated by param.py.  Do not edit. */

#include "param.h"

XYparam_t XYparam[] = {
""")

p = 0
f = open(filename)
for line in f.xreadlines():
	if line[0] == '#' or line[0] == '\n':
		continue
	l = string.split(line)
	h.write("#define %s %d\n" % (l[0], p))
	c.write(" {{ ")
	for x in l[1:NXPARAM + 1]:
		c.write("%s, " % x)
	c.write("}, { ")
	for y in l[NXPARAM + 1:]:
		c.write("%s, " % y)
	c.write("}},\n")
	p += 1

c.write("};\n")

h.write("#define LastParam %d\n" % (p - 1))

c.close()
h.close()
